//////////////////////////////////////////////////////////////////////////
#ifndef SLS_ANT
#define SLS_ANT

#include <math>
#include <vector>
#include "random.h"
#include "acoparams.h"
#include "tourinfo.h"

using namespace std;

class Ant {
private:
	AcoParams *params;
	Random *rand;
	vector<int> notVisited;
	vector<double> p;
	vector<int> tourOrder;
	double tourLength;
	int n_city;
	int currentCity;
	int n_leg;
	
	int selectStartPoint(double *choice_info);
	int selectStartPointRandomly();
	int selectNextStop(double *choice_info);
	int selectNextStopRandomly();
	int selectNextStopDetermin(double *choice_info);
public:
	Ant(AcoParams *ap, Random *r);
	void prepareForJourney();
	void depart(double *choice_info);
	void move(double *choice_info);
	vector<int> getTourOrder();
	void setTourLength(double l);
	//TourInfo makeTour(vector<double> &eta, double *choice_info);
	void secretePheromone(double *tau);
};

#endif //SLS_ANT