//////////////////////////////////////////////////////////////////////
#ifndef SLS_ANTCOLONY
#define SLS_ANTCOLONY

#include <vector>
#include <algorithm>
#include "DeleteObject.h"
#include "random.h"
#include "acoparams.h"
#include "ant.h"
#include "tourinfo.h"

#define MINIMUM_DIST 0.00000001

using namespace std;

class AntColony {
private:
	AcoParams *params;
	double *dist;
	Random *rand;
	double *tau;
	double *choice_info;
	vector<double> eta_beta;
	vector<Ant*> ant;
	int n_city;
	int n_ant;
	TourInfo bestTour;
	TourInfo sendAntsOnJourney();
	double getTourLength(const vector<int> &tourOrder);
	void updatePheromoneLevel();
	void computeChoiceInfo();
	void markBestTour();
public:
	AntColony(AcoParams *ap, double *e);
	AntColony(AcoParams *ap, double *e, unsigned long seed);
	~AntColony();
	void init(AcoParams *ap, double *e);
	TourInfo findBestTour();
	unsigned long getNextSeed();
};

#endif //SLS_ANTCOLONY