/*
AntMap: Software for constructing genetic linkage maps using an Ant Colony Optimization (ACO) algorithm
Copyright (C) 2004 National Agricultural and Bio-oriented Research Organization (NARO)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Hiroyoshi IWATA
Department of Information Science and Technology
National Agricultural Research Center
3-1-1 Kannondai
Tsukuba
Ibaraki 305-8666
JAPAN

ph        +81-298-38-7025
fax       +81-298-38-8551
e-mail    iwatah@affrc.go.jp
*/

//////////////////////////////////////////////////////////////////
#include "random.h"

Random::Random() {
	rand = new MTRand();
}

Random::Random(unsigned long l) {
	rand = new MTRand(l);
}

Random::~Random() {
	if(rand)
		delete rand;
}

unsigned long Random::nextInt() {
	return rand->randInt();
}

unsigned long Random::nextInt(unsigned long l) {
	return rand->randInt(l);
}

double Random::nextDouble() {
	return rand->randExc();
}

double Random::nextDouble(double d) {
	return rand->randExc(d);
}

double Random::nextDoubleInc() {
	return rand->rand();
}

double Random::nextDoubleInc(double d) {
	return rand->rand(d);
}

void Random::setSeed(unsigned long l) {
	rand->seed(l);
}