/*
AntMap: Software for constructing genetic linkage maps using an Ant Colony Optimization (ACO) algorithm
Copyright (C) 2004 National Agricultural and Bio-oriented Research Organization (NARO)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Hiroyoshi IWATA
Department of Information Science and Technology
National Agricultural Research Center
3-1-1 Kannondai
Tsukuba
Ibaraki 305-8666
JAPAN

ph        +81-298-38-7025
fax       +81-298-38-8551
e-mail    iwatah@affrc.go.jp
*/

package org.agmodel.bioinfo.antmap.gui;

import javax.swing.filechooser.FileFilter;
import java.io.File;

/**
 * <p>^Cg: </p>
 * <p>: </p>
 * <p>쌠: Copyright (c) 2004</p>
 * <p>Ж: </p>
 * @author 
 * @version 1.0
 */

public class MyFileFilter extends FileFilter {
  private String extension;
  private String message;

  public MyFileFilter(String extension, String message) {
    this.extension = extension;
    this.message = message;
  }

  public boolean accept(File file) {
    if(file != null) {
      if(file.isDirectory()) {
        return true;
      }
      String tempExt = getExtensionName(file);
      if(tempExt == null) {
        return false;
      } else {
        if(tempExt.equalsIgnoreCase(extension))
          return true;
      }
    }
    return false;
  }

  public String getExtension() {
    return extension;
  }

  public String getMessage() {
    return message;
  }

  private String getExtensionName(File file) {
    String fileName = file.getName();
    int index = fileName.lastIndexOf('.');
    if (index != -1) {
      return fileName.substring(index + 1, fileName.length());
    }
    return null;
  }

  public String getDescription() {
    return message;
  }
}
