/*
AntMap: Software for constructing genetic linkage maps using an Ant Colony Optimization (ACO) algorithm
Copyright (C) 2004 National Agricultural and Bio-oriented Research Organization (NARO)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Hiroyoshi IWATA
Department of Information Science and Technology
National Agricultural Research Center
3-1-1 Kannondai
Tsukuba
Ibaraki 305-8666
JAPAN

ph        +81-298-38-7025
fax       +81-298-38-8551
e-mail    iwatah@affrc.go.jp
*/

package org.agmodel.bioinfo.segregation;

/**
 * @author iwata
 *
 */
public class RecombinationBean implements java.io.Serializable {
	private double value;
	private int n;
	private double chi2;
	private double p;
	private double lod;
	private boolean error;

	public RecombinationBean() {
		value = 0.0;
		chi2 = 0.0;
		p = 1.0;
		lod = 0.0;
		error = false;
	}


	/**
	 * @return
	 */
	public double getChi2() {
		return chi2;
	}

	/**
	 * @return
	 */
	public double getLod() {
		return lod;
	}

	/**
	 * @return
	 */
	public double getP() {
		return p;
	}

	/**
	 * @return
	 */
	public double getValue() {
		return value;
	}

	/**
	 * @param d
	 */
	public void setChi2(double d) {
		chi2 = d;
	}

	/**
	 * @param d
	 */
	public void setLod(double d) {
		lod = d;
	}

	/**
	 * @param d
	 */
	public void setP(double d) {
		p = d;
	}

	/**
	 * @param d
	 */
	public void setValue(double d) {
		value = d;
	}

	/**
	 * @return
	 */
	public boolean isError() {
		return error;
	}

	/**
	 * @param b
	 */
	public void setError(boolean b) {
		error = b;
	}

	/**
	 * @return
	 */
	public int getN() {
		return n;
	}

	/**
	 * @param d
	 */
	public void setN(int d) {
		n = d;
	}

}
