/*
This program (MersenneTwister.java) was originally
 described in "Algorithm dictionary of Java language
 (in Japanese), Gijyutuhyoronsya, Tokyo".
 */

package org.agmodel.bioinfo.stat.rand;

/**
 * @author iwata
 * JavaɂASYTiZp]_Ёjp
 *
 */
public class MersenneTwister extends java.util.Random {
	static final int N = 624;
	static final int M = 397;
	static final int UPPER_MASK = 0x80000000; //1rbg
	static final int LOWER_MASK = 0x7FFFFFFF; //31rbg
	static final int MATRIX_A   = 0x9908B0DF;
	private int x[] = new int[N]; //ԂLziOobt@j
	private int p, q, r; //Oobt@̃CfbNX

    /**
     * Ȃ̃RXgN^
     * ԂV[hɂȂ
     */
	public MersenneTwister() {
		setSeed(System.currentTimeMillis());
	}

	/**
	 * long^̃V[hݒ肷RXgN^
	 * @param seed
	 */
	public MersenneTwister(long seed) {
		setSeed(seed);
	}

	/**
	 * int^̃V[hݒ肷RXgN^
	 * @param seeds
	 */
	public MersenneTwister(int[] seeds) {
		setSeed(seeds);
	}

	/**
	 * long^̃V[h̐ݒ
	 */
	synchronized public void setSeed(long seed) {
		if(x == null) return; //super()̌Ăяoł͉Ȃ
		x[0] = (int) seed;
		for(int i = 1; i < N; i++)
			x[i] = 1812433253 * (x[i - 1] ^ (x[i - 1] >>> 30)) + i;
		p = 0; q = 1; r = M;
	}

	synchronized public void setSeed(int[] seeds) {
		setSeed(19650218);
		int i = 1, j = 0;
		for(int k = 0; k < Math.max(N, seeds.length); k++) {
			x[i] ^= (x[i - 1] ^ (x[i - 1] >>> 30)) * 1664525;
			x[i] += seeds[j] + j;
			if(++i >= N) {
				x[0] = x[N - 1];
				i = 1;
			}
			if(++j >= seeds.length)
				j = 0;
		}
		for(int k = 0; k < N - 1; k++) {
			x[i] ^= (x[i - 1] ^ (x[i - 1] >>> 30)) * 1566083941;
			x[i] -= i;
			if(++i >= N) {
				x[0] = x[N - 1];
				i = 1;
			}
		}
		x[0] = 0x80000000;
	}

	synchronized protected int next(int bits) {
		int y = (x[p] & UPPER_MASK) | (x[q] & LOWER_MASK);
		y = x[p] = x[r] ^ (y >>> 1) ^ ((y & 1) * MATRIX_A);
		if(++p == N) p = 0;   //Oobt@̓Y{P
		if(++q == N) q = 0;
		if(++r == N) r = 0;

		//zǂ钲
		y ^= (y >>> 11);
		y ^= (y <<  7) & 0x9D2C5680;
		y ^= (y << 15) & 0xEFC60000;
		y ^= (y >>> 18);

		return (y >>> (32 - bits));
	}
}
