/*
AntMap: Software for constructing genetic linkage maps using an Ant Colony Optimization (ACO) algorithm
Copyright (C) 2004 National Agricultural and Bio-oriented Research Organization (NARO)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Hiroyoshi IWATA
Department of Information Science and Technology
National Agricultural Research Center
3-1-1 Kannondai
Tsukuba
Ibaraki 305-8666
JAPAN

ph        +81-298-38-7025
fax       +81-298-38-8551
e-mail    iwatah@affrc.go.jp
*/

package org.agmodel.bioinfo.test;

import org.agmodel.bioinfo.antmap.*;

/**
 * @author iwata
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
public class TestAntMap {

	public static void main(String[] args) {
		double [][] dist = {{0.0, 1.0, 2.0, 3.0, 4.0, 5.0},
						     {1.0, 0.0, 1.0, 2.0, 3.0, 4.0},
						     {2.0, 1.0, 0.0, 1.0, 2.0, 3.0},
						     {3.0, 2.0, 1.0, 0.0, 1.0, 2.0},
						     {4.0, 3.0, 2.0, 1.0, 0.0, 1.0},
						     {5.0, 4.0, 3.0, 2.0, 1.0, 0.0}};

		AcoParamsBean acoParams = new AcoParamsBean();
		try {
			acoParams = new AcoParamsReader().loadAcoParamsBean("c:\\eclipse\\workspace\\bioinfo\\etc\\acoparams.txt");
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}

		acoParams.setN_iteration(10000);

		long start = System.currentTimeMillis();
		AntColonyOptimizer aco = new AntColony(acoParams, dist);
		TourBean bestTour = aco.findBestTour();
		bestTour.show();
		System.out.println("Elapsed time: " + (System.currentTimeMillis() - start));

		start = System.currentTimeMillis();
		aco = new AntColonyJNI(acoParams, dist);
		bestTour = aco.findBestTour();
		bestTour.show();
		System.out.println("Elapsed time: " + (System.currentTimeMillis() - start));

	}
}
